//+------------------------------------------------------------------+
//| 2013.                                              BarTimer.mq4 |
//|  BarTimer                               Author: LEXA |
//+------------------------------------------------------------------+
#property copyright "BarTimer"

#property indicator_chart_window
#property indicator_buffers 0

#import "kernel32.dll"
int GetTimeZoneInformation(int& TZInfoArray[]);
#import

extern bool   .. = false;      //      .
extern bool   BarTimer = true;          // BarTimer.
extern bool    = true;          //   .
extern bool    = true;             // .
extern bool   H4 = true;      //  -4.
extern bool    = true;         //  .
extern bool   UTC = true;               //   UTC,BROKER,LOCAL.
extern bool    = true;            //     .
extern bool    = true;            //   $.
extern bool    = true;            //  "".
extern int    BID = 2;          //   Bid (1...3; 0- ).
extern bool   BIDSmall = true;          //    Bid (1/10 ).
extern color  .BID.Default = Gray;          //   Bid   .
extern color  .BID.Price.Up = SpringGreen;  //   Bid Up.
extern color  .BID.Price.Down = Red;        //   Bid Down.
extern color  .BID.Price.Neutral = Orange;  //   Bid Neutral.
extern color  BAR = Black;                  //    .
extern color   = Black;            //   .
extern color  Spread = Black;               //   -4-/.
extern color  UTC = Black;                  //   .
extern color   = Black;               //    .
extern bool    = true;               //     .
extern color   = Gainsboro;             // .
extern bool    = false;       //    .
extern int     = 2;             //0- ; 1-    ; 2-  .
extern string .. =           "==      ==";
extern color  Session = Black;                  //   .
extern color  SessionActive = SeaGreen;         //    .
extern color  SessionMemories = DarkOrange;     //  .
extern color  SessionWarning = FireBrick;       //  .
extern color  SessionOther = SteelBlue;         //   .
extern string . =        "==   ==";
extern string .01 = "EURUSD";
extern string .02 = "GBPUSD";
extern string .03 = "XAUUSD";
extern string .04 = "";
extern string .05 = "";
extern string .06 = "";
extern string .07 = "";
extern string .08 = "";
extern string .09 = "";
extern string .10 = "";
extern string .11 = "";
extern string .12 = "";
extern color   = Black;   //    .
extern string ... = "== 0  / 2  / 1 Buy / -1 Sell ==";
extern int     = 2;                    // : 0 - ; 2 - ; 1 -  BUY; -1 -  SELL.
extern string . = "== 1 - Wingdings / 2 - Wingdings 2 ==";
extern int     = 1;                        // : 1 - Wingdings; 2 - Wingdings 2.
//+------------------------------------------------------------------+
double nPoint=0, sPoint=0, OldPrice; int i=0, sec=0; color Bidd, clr; string TMP, prefix;
int lenbase; string sbase = ":...:...:...:...:"; //      

int init()
  {
   lenbase = StringLen(sbase);
   return(0);
  }
int deinit()
  {
   ObjectDelete(" ");
   ObjectDelete("BarTimer");
   ObjectDelete("  ");
   ObjectDelete(" 4 /");
   ObjectDelete(" BID");
   ObjectDelete(" BIDs");
   ObjectDelete(" UTC");
   ObjectDelete("   ");
   ObjectDelete("   ");
   ObjectDelete(" ");
   ObjectDelete("  ");
   ObjectDelete("   ");
   ObjectDelete("");
   ObjectDelete("");
   ObjectDelete(" ");
   ObjectDelete(" Buy");
   ObjectDelete(" Sell");
   ObjectDelete(" Buy");
   ObjectDelete(" Sell");
   ObjectDelete(" Buy");
   ObjectDelete(" Sell");
   ObjectDelete("Box"); ObjectDelete("Box ");
   for(i=0; i<(OrdersTotal()+5); i++) {TMP = " : " + DoubleToStr(i,0); ObjectDelete(TMP);}
   return(0);
  }
//+------------------------------------------------------------------+
//|            |
//|     ,         |
//|                                   |
//+------------------------------------------------------------------+
int start()
  {
   if (!IsDllsAllowed())
  {
   Comment(" BarTimer:     '  DLL' -     ");
   return (0);
  }
   double pc=0.0; double nPoint = GetPoint(Symbol());
   string time = "", s_end = "", s_beg = "";

   if( >0 ||  <0 ) ShowOrders(MODE_TRADES);

   if (.. == true)
  {
   string Type = "REAL"; if (IsDemo()) {Type = "DEMO";}
   ObjectCreate(" ", OBJ_LABEL, 0, 0, 0);
   ObjectSetText(" ", AccountCompany() + "  " + Type + ": " + AccountNumber() + "  " + AccountName(), 8, "Tahoma", Spread);
   ObjectSet(" ", OBJPROP_CORNER, 0);
   ObjectSet(" ", OBJPROP_XDISTANCE, 4); if (AccountNumber() <= 0) {ObjectDelete(" ");}
  }
   if ( == true)
  {
   ObjectCreate("  ", OBJ_LABEL, 0, 0, 0);
   ObjectSet("  ", OBJPROP_CORNER, 0);
   ObjectSet("  ", OBJPROP_YDISTANCE, 1);
  }
   if (BarTimer == true)
  {
   ObjectCreate("BarTimer", OBJ_LABEL, 0, 0, 0);
   ObjectSet("BarTimer", OBJPROP_CORNER, 0);
   ObjectSet("BarTimer", OBJPROP_XDISTANCE, 262);
   ObjectSet("BarTimer", OBJPROP_YDISTANCE, 1);
   ObjectSet("  ", OBJPROP_XDISTANCE, 420);
  }
   if (BarTimer == false)
  {
   ObjectSet("  ", OBJPROP_XDISTANCE, 262);
  }
   if ( == true)
  {
   ObjectCreate("", OBJ_LABEL, 0, 0, 0);
   ObjectSet("", OBJPROP_CORNER, 3);
   ObjectSet("", OBJPROP_YDISTANCE, 1);
  }
   if ( == true)
  {
   ObjectCreate("", OBJ_LABEL, 0, 0, 0);
   ObjectSet("", OBJPROP_CORNER, 3);
   ObjectSet("", OBJPROP_XDISTANCE, 4);
   ObjectSet("", OBJPROP_YDISTANCE, 1);
   ObjectCreate(" ", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" ", OBJPROP_CORNER, 3);
   ObjectSet(" ", OBJPROP_XDISTANCE, 4);
   ObjectSet(" ", OBJPROP_YDISTANCE, 20);
   ObjectCreate(" Buy", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Buy", OBJPROP_CORNER, 3);
   ObjectSet(" Buy", OBJPROP_XDISTANCE, 4);
   ObjectCreate(" Sell", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Sell", OBJPROP_CORNER, 3);
   ObjectSet(" Sell", OBJPROP_XDISTANCE, 4);
   ObjectSet(" Sell", OBJPROP_YDISTANCE, 40);
   ObjectCreate(" Buy", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Buy", OBJPROP_CORNER, 3);
   ObjectCreate(" Sell", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Sell", OBJPROP_CORNER, 3);
   ObjectSet(" Sell", OBJPROP_YDISTANCE, 40);
   ObjectCreate(" Buy", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Buy", OBJPROP_CORNER, 3);
   ObjectCreate(" Sell", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" Sell", OBJPROP_CORNER, 3);
   ObjectSet(" Sell", OBJPROP_YDISTANCE, 40);
  }
   ObjectCreate(" 4 /", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" 4 /", OBJPROP_CORNER, 0);
   ObjectSet(" 4 /", OBJPROP_XDISTANCE, 4);
   ObjectSet(" 4 /", OBJPROP_YDISTANCE, 12);
   ObjectCreate(" BID", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" BID", OBJPROP_CORNER, 1);
   ObjectSet(" BID", OBJPROP_XDISTANCE, 20);
   ObjectSet(" BID", OBJPROP_YDISTANCE, 2);
   ObjectCreate(" BIDs", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" BIDs", OBJPROP_CORNER, 1);
   ObjectSet(" BIDs", OBJPROP_XDISTANCE, 6);
   ObjectSet(" BIDs", OBJPROP_YDISTANCE, 5);
   ObjectCreate(" ", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" ", OBJPROP_CORNER, 0);
   ObjectSet(" ", OBJPROP_XDISTANCE, 4);
   ObjectCreate("  ", OBJ_LABEL, 0, 0, 0);
   ObjectSet("  ", OBJPROP_CORNER, 0);
   ObjectSet("  ", OBJPROP_XDISTANCE, 4);
   ObjectCreate("   ", OBJ_LABEL, 0, 0, 0);
   ObjectSet("   ", OBJPROP_CORNER, 0);
   ObjectSet("   ", OBJPROP_XDISTANCE, 4);
//+------------------------------------------------------------------+
//|                                               |
//+------------------------------------------------------------------+
   sec = TimeCurrent()-Time[0];        //      
   i = (lenbase-1)*sec/(Period()*60);  //  
   pc = 100.0*sec/(Period()*60);       //      
   if (i>lenbase-1) i = lenbase-1;     //    
   if (i>0) s_beg = StringSubstr(sbase,0,i);
   if (i<lenbase-1) s_end = StringSubstr(sbase,i+1,lenbase-i-1); if (pc>100) {pc=100;}
   time = StringConcatenate(s_beg,"|",s_end," ",DoubleToStr(pc,0),"%");
   ObjectSetText("BarTimer", time, 14, "Arial", BAR);
//+------------------------------------------------------------------+
//|                                           |
//+------------------------------------------------------------------+
   double rates[][6], MyPeriod;
   ArrayCopyRates(rates, NULL, MyPeriod);

   if (StringFind(Symbol(),"XP",0)>=0 || StringFind(Symbol(),"XA",0)>=0) {nPoint=1; sPoint=2;}

   string periodM1  = "M1/"  + DoubleToStr((iHigh(NULL,PERIOD_M1,0)-iLow(NULL,PERIOD_M1,0))/nPoint,sPoint);
   string periodM5  = "M5/"  + DoubleToStr((iHigh(NULL,PERIOD_M5,0)-iLow(NULL,PERIOD_M5,0))/nPoint,sPoint);
   string periodM15 = "M15/" + DoubleToStr((iHigh(NULL,PERIOD_M15,0)-iLow(NULL,PERIOD_M15,0))/nPoint,sPoint) +  "  ";
   string periodM30 = "M30/" + DoubleToStr((iHigh(NULL,PERIOD_M30,0)-iLow(NULL,PERIOD_M30,0))/nPoint,sPoint) +  "  ";
   string periodH1  = "H1/"  + DoubleToStr((iHigh(NULL,PERIOD_H1,0)-iLow(NULL,PERIOD_H1,0))/nPoint,sPoint) +  "  ";
   string periodH4  = "H4/"  + DoubleToStr((iHigh(NULL,PERIOD_H4,0)-iLow(NULL,PERIOD_H4,0))/nPoint,sPoint) +  "  ";
   string periodD1  = "D1/"  + DoubleToStr((iHigh(NULL,PERIOD_D1,0)-iLow(NULL,PERIOD_D1,0))/nPoint,sPoint) +  "  ";
   string periodW1  = "W1/"  + DoubleToStr((iHigh(NULL,PERIOD_W1,0)-iLow(NULL,PERIOD_W1,0))/nPoint,sPoint) +  "  ";
   string periodMN1 = "MN/"  + DoubleToStr((iHigh(NULL,PERIOD_MN1,0)-iLow(NULL,PERIOD_MN1,0))/nPoint,sPoint) +  "  ";
   string periodOLD = "(OLD " + DoubleToStr((rates[1][3]-rates[1][2])/nPoint,sPoint) + ")";

   if (Period() == PERIOD_M1)  {ObjectSetText("  ", periodD1 + periodM1, 14, "Arial", );}
   if (Period() == PERIOD_M5)  {ObjectSetText("  ", periodD1 + periodM5, 14, "Arial", );}
   if (Period() == PERIOD_M15) {ObjectSetText("  ", periodD1 + periodM15 + periodOLD, 14, "Arial", );}
   if (Period() == PERIOD_M30) {ObjectSetText("  ", periodD1 + periodM30 + periodOLD, 14, "Arial", );}
   if (Period() == PERIOD_H1)  {ObjectSetText("  ", periodD1 + periodH1 + periodOLD, 14, "Arial", );}
   if (Period() == PERIOD_H4)  {ObjectSetText("  ", periodD1 + periodH1 + periodH4 + periodOLD, 14, "Arial", );}
   if (Period() >= PERIOD_D1)  {ObjectSetText("  ", periodH4 + periodD1 + periodW1 + periodMN1 + periodOLD, 14, "Arial", );}
//+------------------------------------------------------------------+
//|                               |
//+------------------------------------------------------------------+
   string prefix[12], iclose[12]; double ZY1, ZY2, ZY3, ZY4, MC;

   if (.01!= "") prefix[1]= .01; if (.05!= "") prefix[5]= .05; if (.09!= "") prefix[9] = .09;
   if (.02!= "") prefix[2]= .02; if (.06!= "") prefix[6]= .06; if (.10!= "") prefix[10]= .10;
   if (.03!= "") prefix[3]= .03; if (.07!= "") prefix[7]= .07; if (.11!= "") prefix[11]= .11;
   if (.04!= "") prefix[4]= .04; if (.08!= "") prefix[8]= .08; if (.12!= "") prefix[12]= .12;

   if (StringFind(.01,"JPY",0)>=0 || StringFind(.01,"XA",0)>=0) {MC=2;} else MC=4; iclose[1] = " " + DoubleToStr(iClose(prefix[1],0,0),MC) + "   ";
   if (StringFind(.02,"JPY",0)>=0 || StringFind(.02,"XA",0)>=0) {MC=2;} else MC=4; iclose[2] = " " + DoubleToStr(iClose(prefix[2],0,0),MC) + "   ";
   if (StringFind(.03,"JPY",0)>=0 || StringFind(.03,"XA",0)>=0) {MC=2;} else MC=4; iclose[3] = " " + DoubleToStr(iClose(prefix[3],0,0),MC) + "   ";
   if (StringFind(.04,"JPY",0)>=0 || StringFind(.04,"XA",0)>=0) {MC=2;} else MC=4; iclose[4] = " " + DoubleToStr(iClose(prefix[4],0,0),MC);
   if (StringFind(.05,"JPY",0)>=0 || StringFind(.05,"XA",0)>=0) {MC=2;} else MC=4; iclose[5] = " " + DoubleToStr(iClose(prefix[5],0,0),MC) + "   ";
   if (StringFind(.06,"JPY",0)>=0 || StringFind(.06,"XA",0)>=0) {MC=2;} else MC=4; iclose[6] = " " + DoubleToStr(iClose(prefix[6],0,0),MC) + "   ";
   if (StringFind(.07,"JPY",0)>=0 || StringFind(.07,"XA",0)>=0) {MC=2;} else MC=4; iclose[7] = " " + DoubleToStr(iClose(prefix[7],0,0),MC) + "   ";
   if (StringFind(.08,"JPY",0)>=0 || StringFind(.08,"XA",0)>=0) {MC=2;} else MC=4; iclose[8] = " " + DoubleToStr(iClose(prefix[8],0,0),MC);
   if (StringFind(.09,"JPY",0)>=0 || StringFind(.09,"XA",0)>=0) {MC=2;} else MC=4; iclose[9] = " " + DoubleToStr(iClose(prefix[9],0,0),MC) + "   ";
   if (StringFind(.10,"JPY",0)>=0 || StringFind(.10,"XA",0)>=0) {MC=2;} else MC=4; iclose[10]= " " + DoubleToStr(iClose(prefix[10],0,0),MC) + "   ";
   if (StringFind(.11,"JPY",0)>=0 || StringFind(.11,"XA",0)>=0) {MC=2;} else MC=4; iclose[11]= " " + DoubleToStr(iClose(prefix[11],0,0),MC) + "   ";
   if (StringFind(.12,"JPY",0)>=0 || StringFind(.12,"XA",0)>=0) {MC=2;} else MC=4; iclose[12]= " " + DoubleToStr(iClose(prefix[12],0,0),MC);

   if (iClose(prefix[1],0,0)==0)  {iclose[1]= " - None" + "   ";}
   if (iClose(prefix[2],0,0)==0)  {iclose[2]= " - None" + "   ";}
   if (iClose(prefix[3],0,0)==0)  {iclose[3]= " - None" + "   ";}
   if (iClose(prefix[4],0,0)==0)  {iclose[4]= " - None";}
   if (iClose(prefix[5],0,0)==0)  {iclose[5]= " - None" + "   ";}
   if (iClose(prefix[6],0,0)==0)  {iclose[6]= " - None" + "   ";}
   if (iClose(prefix[7],0,0)==0)  {iclose[7]= " - None" + "   ";}
   if (iClose(prefix[8],0,0)==0)  {iclose[8]= " - None";}
   if (iClose(prefix[9],0,0)==0)  {iclose[9]= " - None" + "   ";}
   if (iClose(prefix[10],0,0)==0) {iclose[10]= " - None" + "   ";}
   if (iClose(prefix[11],0,0)==0) {iclose[11]= " - None" + "   ";}
   if (iClose(prefix[12],0,0)==0) {iclose[12]= " - None";}

   if (.01 == "" || .01 == Symbol()) {string Symb1 = "";}  else  Symb1 = prefix[1] + iclose[1];
   if (.02 == "" || .02 == Symbol()) {string Symb2 = "";}  else  Symb2 = prefix[2] + iclose[2];
   if (.03 == "" || .03 == Symbol()) {string Symb3 = "";}  else  Symb3 = prefix[3] + iclose[3];
   if (.04 == "" || .04 == Symbol()) {string Symb4 = "";}  else  Symb4 = prefix[4] + iclose[4];
   if (.05 == "" || .05 == Symbol()) {string Symb5 = "";}  else  Symb5 = prefix[5] + iclose[5];
   if (.06 == "" || .06 == Symbol()) {string Symb6 = "";}  else  Symb6 = prefix[6] + iclose[6];
   if (.07 == "" || .07 == Symbol()) {string Symb7 = "";}  else  Symb7 = prefix[7] + iclose[7];
   if (.08 == "" || .08 == Symbol()) {string Symb8 = "";}  else  Symb8 = prefix[8] + iclose[8];
   if (.09 == "" || .09 == Symbol()) {string Symb9 = "";}  else  Symb9 = prefix[9] + iclose[9];
   if (.10 == "" || .10 == Symbol()) {string Symb10 = "";} else  Symb10 = prefix[10] + iclose[10];
   if (.11 == "" || .11 == Symbol()) {string Symb11 = "";} else  Symb11 = prefix[11] + iclose[11];
   if (.12 == "" || .12 == Symbol()) {string Symb12 = "";} else  Symb12 = prefix[12] + iclose[12];

   ObjectSetText(" ", Symb1 + Symb2 + Symb3 + Symb4, 8, "Tahoma", );
   ObjectSetText("  ", Symb5 + Symb6 + Symb7 + Symb8, 8, "Tahoma", );
   ObjectSetText("   ", Symb9 + Symb10 + Symb11 + Symb12, 8, "Tahoma", );
//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
   int TZInfoArray[43]; int dst = GetTimeZoneInformation(TZInfoArray); double H4Nexx = 0; int SummerTime; int TMonth = TimeMonth(TimeLocal());

   int TimeZone = TZInfoArray[0];     //       DLL (  GMT)
   if (TMonth <= 3 || TMonth >= 11) SummerTime = 0; else SummerTime = 1; //   / : 0 = , 1 = 

   datetime Broker = TimeCurrent();   //   BROKER
   datetime Local = TimeLocal();      //   LOCAL
   datetime UTC = Local + (TimeZone*60);  //   UTC

   string Brokers = TimeToStr(Broker, TIME_MINUTES); //   BROKER
   string Locals = TimeToStr(Local, TIME_MINUTES);   //   LOCAL
   string UTCs = TimeToStr(UTC, TIME_MINUTES);       //   UTC

   if ( == true)
  {
   if (SummerTime == 1)
  {
   ObjectCreate("   ", OBJ_LABEL, 0, 0, 0);
   ObjectSet("   ", OBJPROP_CORNER, 2);
   ObjectSet("   ", OBJPROP_YDISTANCE, 1);
   ObjectDelete("   ");
  }
   if (SummerTime == 0)
  {
   ObjectCreate("   ", OBJ_LABEL, 0, 0, 0);
   ObjectSet("   ", OBJPROP_CORNER, 2);
   ObjectSet("   ", OBJPROP_YDISTANCE, 1);
   ObjectDelete("   ");
  }}
   if (UTC == true)
  {
   ObjectCreate(" UTC", OBJ_LABEL, 0, 0, 0);
   ObjectSet(" UTC", OBJPROP_CORNER, 2);
   ObjectSet(" UTC", OBJPROP_XDISTANCE, 4);
   ObjectSet(" UTC", OBJPROP_YDISTANCE, 3);
   ObjectSet("   ", OBJPROP_XDISTANCE, 242);
   ObjectSet("   ", OBJPROP_XDISTANCE, 242);
  }
   if (UTC == false)
  {
   ObjectSet("   ", OBJPROP_XDISTANCE, 4);
   ObjectSet("   ", OBJPROP_XDISTANCE, 4);
  }
//+------------------------------------------------------------------+
//|      4            |
//+------------------------------------------------------------------+
   if ( == false)
  {
   int WeekDay = TimeDayOfWeek(TimeLocal()); int HoliDays = 0; datetime TZGMT = (-TimeZone/60);

   if (TZGMT >= 0 && TZGMT <= 2)
  {
   if (WeekDay == 5 && UTCs >= "21:00") HoliDays = 1;
   if (WeekDay == 6 && UTCs >= "00:00") HoliDays = 1;
   if (WeekDay == 0 && UTCs >= "00:00") HoliDays = 1;
   if (WeekDay == 0 && UTCs >= "21:00") HoliDays = 0;
  }
   if (TZGMT == 3)
  {
   if (WeekDay == 6) HoliDays = 1;
   if (WeekDay == 0) HoliDays = 1;
  }
   if (TZGMT >= 4 && TZGMT <= 13)
  {
   if (WeekDay == 6 && TZGMT == 4  && Locals >= "01:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 5  && Locals >= "02:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 6  && Locals >= "03:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 7  && Locals >= "04:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 8  && Locals >= "05:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 9  && Locals >= "06:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 10 && Locals >= "07:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 11 && Locals >= "08:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 12 && Locals >= "09:00") HoliDays = 1;
   if (WeekDay == 6 && TZGMT == 13 && Locals >= "10:00") HoliDays = 1;
   if (WeekDay == 0 && Locals >= "00:00") HoliDays = 1;
   if (WeekDay == 1 && Locals >= "00:00") HoliDays = 1;
   if (WeekDay == 1 && TZGMT == 4  && Locals >= "01:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 5  && Locals >= "02:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 6  && Locals >= "03:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 7  && Locals >= "04:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 8  && Locals >= "05:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 9  && Locals >= "06:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 10 && Locals >= "07:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 11 && Locals >= "08:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 12 && Locals >= "09:00") HoliDays = 0;
   if (WeekDay == 1 && TZGMT == 13 && Locals >= "10:00") HoliDays = 0;
  }}
//+------------------------------------------------------------------+
//|   4                                        |
//+------------------------------------------------------------------+
   if (Brokers >= "00:00") H4Nexx = 04;
   if (Brokers >= "04:00") H4Nexx = 08;
   if (Brokers >= "08:00") H4Nexx = 12;
   if (Brokers >= "12:00") H4Nexx = 16;
   if (Brokers >= "16:00") H4Nexx = 20;
   if (Brokers >= "20:00") H4Nexx = 00;

   datetime H4Nextt = (Local/3600 - Broker/3600 + H4Nexx) * 3600; //   4    ,      

   if (H4 == true)
  {
   string H4Next = "H4 next " + TimeToStr(H4Nextt, TIME_MINUTES) + "   ";
   if (HoliDays == 1) H4Next = "";
  }
   else H4Next = "";
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
   color SColor, , T, B, S;
   color BuyLevel.1 = C'188,215,188'; color BuyLevel.2 = DarkSeaGreen; color BuyLevel.3 = MediumSeaGreen; color BuyLevel.4 = SpringGreen;
   color SelLevel.1 = LightPink; color SelLevel.2 = C'242,153,153'; color SelLevel.3 = Tomato; color SelLevel.4 = FireBrick;
   double Digital = Digits, Points = Point, LotDRB=2, LotDRS=2, MD=1, ZB=0, ZP=0, ZPO=0; string SText, probel = "  ";
   double TickValue = MarketInfo(Symbol(), MODE_TICKVALUE);
   double Balans = AccountBalance(); double FreeMargin = AccountFreeMargin(); string Balanse = "$: " + DoubleToStr(Balans, 0) + "  ";
   double CurrencY = OrdersTotal(); double ProfitAll = AccountProfit();  string Currency = DoubleToStr(OrdersTotal(), 0);
   double Spred = MarketInfo(Symbol(), MODE_SPREAD); double SP=0, SPM=1; if (CurrencY == 0) {Currency = ""; probel = "";}
   if (Balans <= 0) {double MarginPercent=0;} else MarginPercent = ((Balans*FreeMargin)/Balans)/(Balans/100);

   if ( <= 0 ||  >= 3) {string FreeMagrin = "";}
   if ( == 1) {FreeMagrin = "M: " + DoubleToStr(MarginPercent, 0) + "%" + probel;}
   if ( == 2) {FreeMagrin = "M: " + DoubleToStr(AccountFreeMargin(), 0) + probel;}
   if ( == true)
  {
   if (Digital == 4 || Digital <= 2) {SP=0; SPM=1;}
   if (Digital == 5 || Digital == 3) {SP=1; SPM=10;}
   string SpreaD = "Spread " + DoubleToStr(Spred/SPM, SP) + "   ";
  }
   else SpreaD = "";
//+------------------------------------------------------------------+
//|    BID                  |
//+------------------------------------------------------------------+
   double bidd = Bid, askk = Ask; double ima = iMA(Symbol(), PERIOD_M1, 1, 0, MODE_EMA, PRICE_CLOSE, 1);
   string BID, BIDs, sbidd=bidd;

   if (BID <= 0 || BID >= 4) {ObjectDelete(" BID"); ObjectDelete(" BIDs");}
   if (BID == 1) {Bidd = .BID.Default;}
   if (BID == 2)
  {
   if (OldPrice < bidd) {Bidd = .BID.Price.Up;}
   if (OldPrice > bidd) {Bidd = .BID.Price.Down;}
   OldPrice = bidd;
  }
   if (BID == 3)
  {
   if (ima < bidd)  {Bidd = .BID.Price.Up;}
   if (ima > bidd)  {Bidd = .BID.Price.Down;}
   if (ima == bidd) {Bidd = .BID.Price.Neutral;}
  }
   if (Digital == 4 || Digital <= 2)
  {
   ObjectDelete(" BIDs"); ObjectSet(" BID", OBJPROP_XDISTANCE, 6); BID = DoubleToStr(bidd, Digital);
  }
   if (Digital == 5 || Digital == 3)
  {
   Digital = Digital - 1; BID = StringSubstr(sbidd, 0, 6); BIDs = StringSubstr(sbidd, 6, 1);
   if (StringFind(Symbol(),"JPY",0)>=0 && bidd >= 100) {BID = StringSubstr(sbidd, 0, 6); BIDs = StringSubstr(sbidd, 6, 1);}
   if (StringFind(Symbol(),"JPY",0)>=0 && bidd < 100)  {BID = StringSubstr(sbidd, 0, 5); BIDs = StringSubstr(sbidd, 5, 1);}
   if (BIDSmall == false) {ObjectDelete(" BIDs"); ObjectSet(" BID", OBJPROP_XDISTANCE, 6); BID = DoubleToStr(bidd, Digital);}
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
   double LotB=0, LotS=0, Profit=0, ProfitBuy=0, ProfitSell=0, LotBuy=0, LotSell=0, PosBuy=0, PosSell=0, PriceBzu=0, FntB=14, FntS=14, FntR; string PoSB, PoSS, FontB, FontS;

   for (int a1=0; a1<OrdersTotal(); a1++)
   if ((OrderSelect(a1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_BUY))ProfitBuy+=OrderProfit()+OrderCommission()+OrderSwap();
   for (int b1=0; b1<OrdersTotal(); b1++)
   if ((OrderSelect(b1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_BUY))LotBuy+=OrderLots();
   for (int c1=0; c1<OrdersTotal(); c1++)
   if ((OrderSelect(c1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_BUY))PosBuy+=OrderSelect(c1, SELECT_BY_POS);

   for (int d1=0; d1<OrdersTotal(); d1++)
   if ((OrderSelect(d1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_SELL))ProfitSell+=OrderProfit()+OrderCommission()+OrderSwap();
   for (int e1=0; e1<OrdersTotal(); e1++)
   if ((OrderSelect(e1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_SELL))LotSell+=OrderLots();
   for (int f1=0; f1<OrdersTotal(); f1++)
   if ((OrderSelect(f1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_SELL))PosSell+=OrderSelect(f1, SELECT_BY_POS);

   for (int g1=0; g1<OrdersTotal(); g1++)
   if ((OrderSelect(g1, SELECT_BY_POS, MODE_TRADES))&&(OrderType()==OP_BUY))LotB+=OrderLots();
   for (int h1=0; h1<OrdersTotal(); h1++)
   if ((OrderSelect(h1, SELECT_BY_POS, MODE_TRADES))&&(OrderType()==OP_SELL))LotS+=OrderLots();

   double allpos = PosSell + PosBuy; if (LotBuy >= 10) {LotDRB=1;} if (LotSell >= 10) {LotDRS=1;}
   if (LotB+LotS == 0) {string LotALL = "";} else LotALL = "/" + DoubleToStr(LotB+LotS, 2);
   if (LotB+LotS >= 1) {LotALL = "/" + DoubleToStr(LotB+LotS, 1);}

   for (int w1=0; w1<OrdersTotal(); w1++)
   if ((OrderSelect(w1, SELECT_BY_POS, MODE_TRADES))&&(OrderSymbol()==Symbol())&&(OrderType()==OP_BUY)||(OrderType()==OP_SELL))Profit+=OrderProfit()+OrderCommission()+OrderSwap();
   if (allpos == 0) {string ProfiT = " ";} else ProfiT = "PROFIT: " + DoubleToStr(Profit, 2);

   if (ProfitBuy >= 10 || ProfitSell >= 10) {ZP=4;} if (ProfitBuy <= -10 || ProfitSell <= -10) {ZP=7;}
   if (ProfitBuy >= 100 || ProfitSell >= 100) {ZP=14;} if (ProfitBuy <= -100 || ProfitSell <= -100) {ZP=17;}
   if (ProfitBuy >= 1000 || ProfitSell >= 1000) {ZP=24;} if (ProfitBuy <= -1000 || ProfitSell <= -1000) {ZP=27;}
   if (ProfitBuy >= 10000 || ProfitSell >= 10000) {ZP=34; ZB=8;} if (ProfitBuy <= -10000 || ProfitSell <= -10000) {ZP=37; ZB=10;}
   if (ProfitBuy >= 100000 || ProfitSell >= 100000) {ZP=44; ZB=16;} if (ProfitBuy <= -100000 || ProfitSell <= -100000) {ZP=47; ZB=18;}
   if (ProfitBuy >= 1000000 || ProfitSell >= 1000000) {ZP=54; ZB=24;} if (ProfitBuy <= -1000000 || ProfitSell <= -1000000) {ZP=57; ZB=27;}

   if (ProfitAll <= -100 || Profit <= -100) {ZB=5;}
   if (ProfitAll >= 1000 || Profit >= 1000) {ZB=10;} if (ProfitAll <= -1000 || Profit <= -1000) {ZB=14;}
   if (ProfitAll >= 10000 || Profit >= 10000) {ZB=19;} if (ProfitAll <= -10000 || Profit <= -10000) {ZB=24;}
   if (ProfitAll >= 100000 || Profit >= 100000) {ZB=27;} if (ProfitAll <= - 100000 || Profit <= -100000) {ZB=27;}
   if (ProfitAll >= 1000000 || Profit >= 1000000) {ZB=27;} if (ProfitAll <= - 1000000 || Profit <= -1000000) {ZB=27;}

   if (PosSell == 0) {ObjectSet(" Buy", OBJPROP_YDISTANCE, 40);} else ObjectSet(" Buy", OBJPROP_YDISTANCE, 60);
   if (PosSell == 0) {ObjectSet(" Buy", OBJPROP_YDISTANCE, 40);} else ObjectSet(" Buy", OBJPROP_YDISTANCE, 60);
   if (LotSell == 0) {ObjectSet(" Buy", OBJPROP_YDISTANCE, 40);} else ObjectSet(" Buy", OBJPROP_YDISTANCE, 60);
   if (CurrencY == 0) {ObjectDelete(""); ObjectSet("", OBJPROP_XDISTANCE, 4);} else ObjectSet("", OBJPROP_XDISTANCE, 142+ZB);

   if (PosBuy == 0) {string ProfitBUY = " ";} else ProfitBUY = DoubleToStr(ProfitBuy, 2);
   if (PosSell == 0){string ProfitSELL = " ";} else ProfitSELL = DoubleToStr(ProfitSell, 2);
   if (LotBuy == 0) {string LotBUY = " ";} else LotBUY = DoubleToStr(LotBuy, LotDRB);
   if (LotSell == 0){string LotSELL = " ";} else LotSELL = DoubleToStr(LotSell, LotDRS);
//+------------------------------------------------------------------+
//|                                     |
//+------------------------------------------------------------------+
   if (  == true)
  {
   if (allpos >= 1)
  {
   ObjectCreate("Box", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Box", "g", 60, "Webdings", );
   ObjectSet("Box", OBJPROP_CORNER, 3);
   ObjectSet("Box", OBJPROP_XDISTANCE, 2);
   ObjectSet("Box", OBJPROP_YDISTANCE, 2);
   ObjectSet("Box", OBJPROP_BACK, FALSE);

   ObjectCreate("Box ", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Box ", "g", 60, "Webdings", );
   ObjectSet("Box ", OBJPROP_CORNER, 3);
   ObjectSet("Box ", OBJPROP_XDISTANCE, 54+ZB);
   ObjectSet("Box ", OBJPROP_YDISTANCE, 2);
   ObjectSet("Box ", OBJPROP_BACK, FALSE);
  }
   if (allpos == 0)
  {
   ObjectDelete("Box"); ObjectDelete("Box ");
  }}
   if ( == false)
  {
   ObjectDelete("Box"); ObjectDelete("Box ");
   ObjectSet("", OBJPROP_XDISTANCE, 4);
  }
//+------------------------------------------------------------------+
//|   (   -  !)          |
//+------------------------------------------------------------------+
   if ((LotBuy - LotSell) > 0) {PriceBzu = bidd - ((ProfitBuy + ProfitSell) / (TickValue * (LotBuy - LotSell)) * Points);}
   if ((LotSell - LotBuy) > 0) {PriceBzu = askk + ((ProfitBuy + ProfitSell) / (TickValue * (LotSell - LotBuy)) * Points);}

   if ( == true)
  {
   if (PriceBzu > 0) string PriceBzub = DoubleToStr(PriceBzu, Digital);
   else  PriceBzub = "";
  }
   else  PriceBzub = "";
//+---------------------------------------------------------------------------------+
//|    , H4, , ,  |
//+---------------------------------------------------------------------------------+
  if (SpreaD == "" && H4Next == "" && PriceBzub == "") { = false; H4 = false;  = false;}

  if ( == false && H4 == false &&  == false)
  { 
   ZY1=12; ZY2=24; ZY3=36; ZY4=48;
   if (Symb1 == "" && Symb2 == "" && Symb3 == "" && Symb4 == "")    {ZY2=ZY2-12; ZY3=ZY3-12; ZY4=ZY4-12;}
   if (Symb5 == "" && Symb6 == "" && Symb7 == "" && Symb8 == "")    {ZY3=ZY3-12; ZY4=ZY4-12;}
   if (Symb9 == "" && Symb10 == "" && Symb11 == "" && Symb12 == "") {ZY4=ZY4-12;}
  }
   else
  {
   ZY1=24; ZY2=36; ZY3=48; ZY4=60;
   if (Symb1 == "" && Symb2 == "" && Symb3 == "" && Symb4 == "")    {ZY2=ZY2-12; ZY3=ZY3-12; ZY4=ZY4-12;}
   if (Symb5 == "" && Symb6 == "" && Symb7 == "" && Symb8 == "")    {ZY3=ZY3-12; ZY4=ZY4-12;}
   if (Symb9 == "" && Symb10 == "" && Symb11 == "" && Symb12 == "") {ZY4=ZY4-12;}
  }
   if ( == true  && BarTimer == true  && ZY4==12) {ZY4=24;}
   if ( == false && BarTimer == true  && ZY4==12) {ZY4=24;}
   if ( == true  && BarTimer == false && ZY4==12) {ZY4=24;}

   ObjectSet(" ", OBJPROP_YDISTANCE, ZY1);
   ObjectSet("  ", OBJPROP_YDISTANCE, ZY2);
   ObjectSet("   ", OBJPROP_YDISTANCE, ZY3);
   ObjectSet(" ", OBJPROP_YDISTANCE, ZY4);
//+------------------------------------------------------------------+
//|                            |
//+------------------------------------------------------------------+
   if (Balans >= 2000) {MD=2;}  if (Balans >= 3000)  {MD=3;}   if (Balans >= 4000)   {MD=4;}
   if (Balans >= 5000) {MD=5;}  if (Balans >= 6000)  {MD=6;}   if (Balans >= 7000)   {MD=7;}
   if (Balans >= 8000) {MD=8;}  if (Balans >= 9000)  {MD=9;}   if (Balans >= 10000)  {MD=10;}
   if (Balans >= 50000){MD=50;} if (Balans >= 100000){MD=100;} if (Balans >= 1000000){MD=1000;}

   if (ProfitAll >= 0.00 || ProfitAll <= 0.00){ = ;} if (Profit >= 0.00 || Profit <= 0.00){T = ;}
   if (ProfitAll >= 1.00*MD)    { = BuyLevel.1;} if (Profit >= 1.00*MD)    {T = BuyLevel.1;}
   if (ProfitAll >= 5.00*MD)    { = BuyLevel.2;} if (Profit >= 5.00*MD)    {T = BuyLevel.2;}
   if (ProfitAll >= 30.00*MD)   { = BuyLevel.3;} if (Profit >= 30.00*MD)   {T = BuyLevel.3;}
   if (ProfitAll >= 100.00*MD)  { = BuyLevel.4;} if (Profit >= 100.00*MD)  {T = BuyLevel.4;}
   if (ProfitAll <= -1.00*MD)   { = SelLevel.1;} if (Profit <= -1.00*MD)   {T = SelLevel.1;}
   if (ProfitAll <= -5.00*MD)   { = SelLevel.2;} if (Profit <= -5.00*MD)   {T = SelLevel.2;}
   if (ProfitAll <= -30.00*MD)  { = SelLevel.3;} if (Profit <= -30.00*MD)  {T = SelLevel.3;}
   if (ProfitAll <= -100.00*MD) { = SelLevel.4;} if (Profit <= -100.00*MD) {T = SelLevel.4;}

   if (ProfitBuy >= 0.00 || ProfitBuy <= 0.00){B = ;} if (ProfitSell >= 0.00 || ProfitSell <= 0.00){S = ;}
   if (ProfitBuy >= 1.00*MD)    {B = BuyLevel.1;} if (ProfitSell >= 1.00*MD)    {S = BuyLevel.1;}
   if (ProfitBuy >= 5.00*MD)    {B = BuyLevel.2;} if (ProfitSell >= 5.00*MD)    {S = BuyLevel.2;}
   if (ProfitBuy >= 30.00*MD)   {B = BuyLevel.3;} if (ProfitSell >= 30.00*MD)   {S = BuyLevel.3;}
   if (ProfitBuy >= 100.00*MD)  {B = BuyLevel.4;} if (ProfitSell >= 100.00*MD)  {S = BuyLevel.4;}
   if (ProfitBuy <= -1.00*MD)   {B = SelLevel.1;} if (ProfitSell <= -1.00*MD)   {S = SelLevel.1;}
   if (ProfitBuy <= -5.00*MD)   {B = SelLevel.2;} if (ProfitSell <= -5.00*MD)   {S = SelLevel.2;}
   if (ProfitBuy <= -30.00*MD)  {B = SelLevel.3;} if (ProfitSell <= -30.00*MD)  {S = SelLevel.3;}
   if (ProfitBuy <= -100.00*MD) {B = SelLevel.4;} if (ProfitSell <= -100.00*MD) {S = SelLevel.4;}

   if ( <= 1) {FontB = "Wingdings"; FontS = "Wingdings"; FntR=23;}
   if ( >= 2) {FontB = "Wingdings 2"; FontS = "Wingdings 2"; FntR=0;}

   if (PosBuy == 0)  {PoSB = " ";}                 if (PosSell == 0)  {PoSS = " ";}
   if (PosBuy == 1)  {PoSB = CharToStr(117+FntR);} if (PosSell == 1)  {PoSS = CharToStr(117+FntR);}
   if (PosBuy == 2)  {PoSB = CharToStr(118+FntR);} if (PosSell == 2)  {PoSS = CharToStr(118+FntR);}
   if (PosBuy == 3)  {PoSB = CharToStr(119+FntR);} if (PosSell == 3)  {PoSS = CharToStr(119+FntR);}
   if (PosBuy == 4)  {PoSB = CharToStr(120+FntR);} if (PosSell == 4)  {PoSS = CharToStr(120+FntR);}
   if (PosBuy == 5)  {PoSB = CharToStr(121+FntR);} if (PosSell == 5)  {PoSS = CharToStr(121+FntR);}
   if (PosBuy == 6)  {PoSB = CharToStr(122+FntR);} if (PosSell == 6)  {PoSS = CharToStr(122+FntR);}
   if (PosBuy == 7)  {PoSB = CharToStr(123+FntR);} if (PosSell == 7)  {PoSS = CharToStr(123+FntR);}
   if (PosBuy == 8)  {PoSB = CharToStr(124+FntR);} if (PosSell == 8)  {PoSS = CharToStr(124+FntR);}
   if (PosBuy == 9)  {PoSB = CharToStr(125+FntR);} if (PosSell == 9)  {PoSS = CharToStr(125+FntR);}
   if (PosBuy == 10) {PoSB = CharToStr(126+FntR);} if (PosSell == 10) {PoSS = CharToStr(126+FntR);}

   if (PosBuy >= 11) {FontB = "Arial Black"; FntB=11; ZPO=3; PoSB = DoubleToStr(PosBuy,0);}
   if (PosSell >= 11){FontS = "Arial Black"; FntS=11; ZPO=3; PoSS = DoubleToStr(PosSell,0);}

   ObjectSet(" Buy", OBJPROP_XDISTANCE, 48+ZP); ObjectSet(" Sell", OBJPROP_XDISTANCE, 48+ZP);
   ObjectSet(" Buy", OBJPROP_XDISTANCE, 66+ZP+ZPO); ObjectSet(" Sell", OBJPROP_XDISTANCE, 66+ZP+ZPO);
//+------------------------------------------------------------------+
//|    ,          |
//+------------------------------------------------------------------+
   ObjectSetText("", Balanse + FreeMagrin + Currency + LotALL, 11, "Arial Black", );
   ObjectSetText("", "  TOTAL: " + DoubleToStr(ProfitAll, 2), 11, "Arial Black", );
   ObjectSetText(" ", ProfiT, 11, "Arial Black", T);
   ObjectSetText(" Buy", ProfitBUY, 11, "Arial Black", B);
   ObjectSetText(" Sell", ProfitSELL, 11, "Arial Black", S);
   ObjectSetText(" Buy", PoSB, FntB, FontB, SeaGreen);
   ObjectSetText(" Sell", PoSS, FntS, FontS, Brown);
   ObjectSetText(" Buy", LotBUY, 11, "Arial Black", );
   ObjectSetText(" Sell", LotSELL, 11, "Arial Black", );
   ObjectSetText(" BID", BID, 26, "Arial", Bidd);
   ObjectSetText(" BIDs", BIDs, 14, "Arial", Bidd);
   ObjectSetText(" 4 /", SpreaD + H4Next + PriceBzub, 8, "Tahoma", Spread);
   ObjectSetText(" UTC", "UTC " + UTCs + "  BROKER " + Brokers + "  LOCAL " + Locals, 9, "Tahoma", UTC);
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
   if (SummerTime == 1)
  {
   if (UTCs >= "00:00") {SText = " = OPEN ASIA SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "00:01") {SText = " = ASIA SESSION ACTIVE FIRST HOUR= "; SColor = SessionActive;}
   if (UTCs >= "01:00") {SText = " = ASIA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "02:00") {SText = " = ASIA SESSION = "; SColor = Session;}
   if (UTCs >= "06:00") {SText = " = ASIA CLOSE - EUROPA OPEN 60M = "; SColor = SessionMemories;}
   if (UTCs >= "06:01") {SText = " = ASIA SESSION LAST HOUR = "; SColor = Session;}
   if (UTCs >= "06:30") {SText = " = ASIA CLOSE - EUROPA OPEN 30M = "; SColor = SessionMemories;}
   if (UTCs >= "06:31") {SText = " = ASIA SESSION LAST 30M = "; SColor = Session;}
   if (UTCs >= "06:45") {SText = " = ASIA CLOSE - EUROPA OPEN 15M = "; SColor = SessionMemories;}
   if (UTCs >= "06:46") {SText = " = ASIA SESSION LAST 15M = "; SColor = Session;}
   if (UTCs >= "06:50") {SText = " = ASIA CLOSE - EUROPA OPEN 10M = "; SColor = SessionMemories;}
   if (UTCs >= "06:51") {SText = " = ASIA SESSION LAST 10M = "; SColor = Session;}
   if (UTCs >= "06:55") {SText = " = ASIA CLOSE 5M - EUROPA OPEN 5M = "; SColor = SessionMemories;}
   if (UTCs >= "06:59") {SText = " = ASIA CLOSE SESSION - EUROPA OPEN SESSION = "; SColor = SessionWarning;}
   if (UTCs >= "07:00") {SText = " = OPEN EUROPA SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "07:01") {SText = " = EUROPA SESSION ACTIVE FIRST HOUR = "; SColor = SessionActive;}
   if (UTCs >= "08:00") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "11:00") {SText = " = EUROPA SESSION = "; SColor = Session;}
   if (UTCs >= "12:30") {SText = " = EUROPA SESSION - AMERICA OPEN 60M = "; SColor = SessionMemories;}
   if (UTCs >= "12:31") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "13:00") {SText = " = EUROPA ACTIVE - AMERICA OPEN 30M = "; SColor = SessionMemories;}
   if (UTCs >= "13:01") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "13:15") {SText = " = EUROPA ACTIVE - AMERICA OPEN 15M = "; SColor = SessionMemories;}
   if (UTCs >= "13:16") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "13:20") {SText = " = EUROPA ACTIVE - AMERICA OPEN 10M = "; SColor = SessionMemories;}
   if (UTCs >= "13:21") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "13:25") {SText = " = EUROPA ACTIVE - AMERICA OPEN 5M = "; SColor = SessionMemories;}
   if (UTCs >= "13:30") {SText = " = EUROPA - AMERICA OPEN SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "13:31") {SText = " = EUROPA - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "14:30") {SText = " = EUROPA CLOSE 60M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "14:31") {SText = " = EUROPA LAST HOUR - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "15:00") {SText = " = EUROPA CLOSE 30M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "15:01") {SText = " = EUROPA LAST 30M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "15:15") {SText = " = EUROPA CLOSE 15M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "15:16") {SText = " = EUROPA LAST 15M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "15:20") {SText = " = EUROPA CLOSE 10M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "15:21") {SText = " = EUROPA LAST 10M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "15:25") {SText = " = EUROPA CLOSE 5M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "15:29") {SText = " = EUROPA CLOSE SESSION - AMERICA SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "15:30") {SText = " = AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "17:00") {SText = " = AMERICA SESSION = "; SColor = Session;}
   if (UTCs >= "19:00") {SText = " = AMERICA SESSION ACTIVE CLOSE 60M = "; SColor = SessionMemories;}
   if (UTCs >= "19:01") {SText = " = AMERICA SESSION ACTIVE LAST HOUR = "; SColor = SessionActive;}
   if (UTCs >= "19:30") {SText = " = AMERICA SESSION ACTIVE CLOSE 30M = "; SColor = SessionMemories;}
   if (UTCs >= "19:31") {SText = " = AMERICA SESSION ACTIVE LAST 30M = "; SColor = SessionActive;}
   if (UTCs >= "19:45") {SText = " = AMERICA SESSION ACTIVE CLOSE 15M = "; SColor = SessionMemories;}
   if (UTCs >= "19:46") {SText = " = AMERICA SESSION ACTIVE LAST 15M = "; SColor = SessionActive;}
   if (UTCs >= "19:50") {SText = " = AMERICA SESSION ACTIVE CLOSE 10M = "; SColor = SessionMemories;}
   if (UTCs >= "19:51") {SText = " = AMERICA SESSION ACTIVE LAST 10M = "; SColor = SessionActive;}
   if (UTCs >= "19:55") {SText = " = AMERICA SESSION ACTIVE CLOSE 5M = "; SColor = SessionMemories;}
   if (UTCs >= "19:59") {SText = " = AMERICA CLOSE SESSION = "; SColor = SessionWarning;}
   if (UTCs >= "20:00") {SText = " = NOT ACTIVE SESSION = "; SColor = Session;}
   if (UTCs >= "20:01") {SText = " = CLOSE OLD TRADE DAY 60M = "; SColor = SessionMemories;}
   if (UTCs >= "20:02") {SText = " = NOT ACTIVE SESSION = "; SColor = Session;}
   if (UTCs >= "20:30") {SText = " = CLOSE OLD TRADE DAY 30M = "; SColor = SessionMemories;}
   if (UTCs >= "20:31") {SText = " = NOT ACTIVE SESSION = "; SColor = Session;}
   if (UTCs >= "20:45") {SText = " = CLOSE OLD TRADE DAY 15M = "; SColor = SessionMemories;}
   if (UTCs >= "20:46") {SText = " = NOT ACTIVE SESSION = "; SColor = Session;}
   if (UTCs >= "20:55") {SText = " = CLOSE OLD TRADE DAY 5M = "; SColor = SessionWarning;}
   if (UTCs >= "21:00") {SText = " = NEW TRADE DAY = "; SColor = SessionOther;}
   if (UTCs >= "21:01") {SText = " = OPEN NEW TRADE DAY = "; SColor = SessionMemories;}
   if (UTCs >= "21:05") {SText = " = NEW ZELAND = "; SColor = Session;}
   if (UTCs >= "23:00") {SText = " = ASIA OPEN SESSION 60M = "; SColor = SessionMemories;}
   if (UTCs >= "23:01") {SText = " = NEW ZELAND = "; SColor = Session;}
   if (UTCs >= "23:45") {SText = " = ASIA OPEN SESSION 15M = "; SColor = SessionMemories;}
   if (UTCs >= "23:46") {SText = " = NEW ZELAND = "; SColor = Session;}
   if (UTCs >= "23:50") {SText = " = ASIA OPEN SESSION 10M = "; SColor = SessionMemories;}
   if (UTCs >= "23:51") {SText = " = NEW ZELAND = "; SColor = Session;}
   if (UTCs >= "23:55") {SText = " = ASIA OPEN SESSION 5M = "; SColor = SessionMemories;}
   if (UTCs == "23:59") {SText = " = ASIA OPEN SESSION 1M = "; SColor = SessionWarning;}

   if (HoliDays == 1) {SText = " = MARKET CLOSE FOR TRADING = "; SColor = SessionOther;}
   ObjectSetText("   ", SText, 9 , "Arial Black", SColor);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
   if (SummerTime == 0)
  {
   if (UTCs >= "00:00") {SText = " = OPEN ASIA SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "00:01") {SText = " = ASIA SESSION ACTIVE FIRST HOUR= "; SColor = SessionActive;}
   if (UTCs >= "01:00") {SText = " = ASIA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "02:00") {SText = " = ASIA SESSION = "; SColor = Session;}
   if (UTCs >= "06:00") {SText = " = ASIA CLOSE - EUROPA OPEN 60M = "; SColor = SessionMemories;}
   if (UTCs >= "06:01") {SText = " = ASIA SESSION LAST HOUR = "; SColor = Session;}
   if (UTCs >= "06:30") {SText = " = ASIA CLOSE - EUROPA OPEN 30M = "; SColor = SessionMemories;}
   if (UTCs >= "06:31") {SText = " = ASIA SESSION LAST 30M = "; SColor = Session;}
   if (UTCs >= "06:45") {SText = " = ASIA CLOSE - EUROPA OPEN 15M = "; SColor = SessionMemories;}
   if (UTCs >= "06:46") {SText = " = ASIA SESSION LAST 15M = "; SColor = Session;}
   if (UTCs >= "06:50") {SText = " = ASIA CLOSE - EUROPA OPEN 10M = "; SColor = SessionMemories;}
   if (UTCs >= "06:51") {SText = " = ASIA SESSION LAST 10M = "; SColor = Session;}
   if (UTCs >= "06:55") {SText = " = ASIA CLOSE 5M - EUROPA OPEN 5M = "; SColor = SessionMemories;}
   if (UTCs >= "06:59") {SText = " = ASIA CLOSE SESSION - EUROPA OPEN SESSION = "; SColor = SessionWarning;}
   if (UTCs >= "07:00") {SText = " = OPEN EUROPA SESSION ACTIVE= "; SColor = SessionWarning;}
   if (UTCs >= "07:01") {SText = " = EUROPA SESSION ACTIVE FIRST HOUR = "; SColor = SessionActive;}
   if (UTCs >= "08:00") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "11:00") {SText = " = EUROPA SESSION = "; SColor = Session;}
   if (UTCs >= "13:00") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "13:30") {SText = " = EUROPA ACTIVE - AMERICA OPEN 60M = "; SColor = SessionMemories;}
   if (UTCs >= "13:31") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "14:00") {SText = " = EUROPA ACTIVE - AMERICA OPEN 30M = "; SColor = SessionMemories;}
   if (UTCs >= "14:01") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "14:15") {SText = " = EUROPA ACTIVE - AMERICA OPEN 15M = "; SColor = SessionMemories;}
   if (UTCs >= "14:16") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "14:20") {SText = " = EUROPA ACTIVE - AMERICA OPEN 10M = "; SColor = SessionMemories;}
   if (UTCs >= "14:21") {SText = " = EUROPA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "14:25") {SText = " = EUROPA ACTIVE - AMERICA OPEN 5M = "; SColor = SessionMemories;}
   if (UTCs >= "14:30") {SText = " = EUROPA - AMERICA OPEN SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "14:31") {SText = " = EUROPA - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "15:30") {SText = " = EUROPA CLOSE 60M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "15:31") {SText = " = EUROPA LAST HOUR - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "16:00") {SText = " = EUROPA CLOSE 30M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "16:01") {SText = " = EUROPA LAST 30M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "16:15") {SText = " = EUROPA CLOSE 15M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "16:16") {SText = " = EUROPA LAST 15M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "16:20") {SText = " = EUROPA CLOSE 10M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "16:21") {SText = " = EUROPA LAST 10M - AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "16:25") {SText = " = EUROPA CLOSE 5M - AMERICA SESSION ACTIVE = "; SColor = SessionMemories;}
   if (UTCs >= "16:29") {SText = " = EUROPA CLOSE SESSION - AMERICA SESSION ACTIVE = "; SColor = SessionWarning;}
   if (UTCs >= "16:30") {SText = " = AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "17:00") {SText = " = AMERICA SESSION = "; SColor = Session;}
   if (UTCs >= "19:00") {SText = " = AMERICA SESSION ACTIVE = "; SColor = SessionActive;}
   if (UTCs >= "20:00") {SText = " = AMERICA SESSION ACTIVE CLOSE 60M = "; SColor = SessionMemories;}
   if (UTCs >= "20:01") {SText = " = CLOSE OLD TRADE DAY 60M = "; SColor = SessionMemories;}
   if (UTCs >= "20:02") {SText = " = AMERICA SESSION ACTIVE LAST HOUR = "; SColor = SessionActive;}
   if (UTCs >= "20:30") {SText = " = CLOSE OLD TRADE DAY 30M = "; SColor = SessionMemories;}
   if (UTCs >= "20:31") {SText = " = AMERICA SESSION ACTIVE CLOSE 30M = "; SColor = SessionMemories;}
   if (UTCs >= "20:32") {SText = " = AMERICA SESSION ACTIVE LAST 30M = "; SColor = SessionActive;}
   if (UTCs >= "20:45") {SText = " = CLOSE OLD TRADE DAY 15M = "; SColor = SessionMemories;}
   if (UTCs >= "20:46") {SText = " = AMERICA SESSION ACTIVE CLOSE 15M = "; SColor = SessionMemories;}
   if (UTCs >= "20:47") {SText = " = AMERICA SESSION ACTIVE LAST 15M = "; SColor = SessionActive;}
   if (UTCs >= "20:50") {SText = " = AMERICA SESSION ACTIVE CLOSE 10M = "; SColor = SessionMemories;}
   if (UTCs >= "20:51") {SText = " = AMERICA SESSION ACTIVE LAST 10M = "; SColor = SessionActive;}
   if (UTCs >= "20:55") {SText = " = CLOSE OLD TRADE DAY 5M = "; SColor = SessionWarning;}
   if (UTCs >= "20:56") {SText = " = AMERICA SESSION ACTIVE CLOSE 5M = "; SColor = SessionMemories;}
   if (UTCs >= "20:59") {SText = " = AMERICA CLOSE SESSION = "; SColor = SessionWarning;}
   if (UTCs >= "21:00") {SText = " = NEW TRADE DAY = "; SColor = SessionOther;}
   if (UTCs >= "21:01") {SText = " = OPEN NEW TRADE DAY = "; SColor = SessionMemories;}
   if (UTCs >= "21:05") {SText = " = NEW ZELAND = "; SColor = Session;}
   if (UTCs >= "23:00") {SText = " = ASIA OPEN SESSION 60M = "; SColor = SessionMemories;}
   if (UTCs >= "23:01") {SText = " = NEW ZELAND + AUSTRALIA = "; SColor = Session;}
   if (UTCs >= "23:30") {SText = " = ASIA OPEN SESSION 30M = "; SColor = SessionMemories;}
   if (UTCs >= "23:31") {SText = " = NEW ZELAND + AUSTRALIA = "; SColor = Session;}
   if (UTCs >= "23:45") {SText = " = ASIA OPEN SESSION 15M = "; SColor = SessionMemories;}
   if (UTCs >= "23:46") {SText = " = NEW ZELAND + AUSTRALIA = "; SColor = Session;}
   if (UTCs >= "23:50") {SText = " = ASIA OPEN SESSION 10M = "; SColor = SessionMemories;}
   if (UTCs >= "23:51") {SText = " = NEW ZELAND + AUSTRALIA = "; SColor = Session;}
   if (UTCs >= "23:55") {SText = " = ASIA OPEN SESSION 5M = "; SColor = SessionMemories;}
   if (UTCs == "23:59") {SText = " = ASIA OPEN SESSION 1M = "; SColor = SessionWarning;}

   if (HoliDays == 1) {SText = " = MARKET CLOSE FOR TRADING = "; SColor = SessionOther;}
   ObjectSetText("   ", SText, 9 , "Arial Black", SColor);
  }
//+------------------------------------------------------------------+
   return(0);
  }
   double GetPoint(string vSymbol)
  {
   int vres = StringFind(vSymbol,"JPY",0);
   if (vres == -1) return(0.0001); return(0.01);
  }
//+------------------------------------------------------------------+
//|                        |
//+------------------------------------------------------------------+
   void ShowOrders(int mode = MODE_TRADES)
  {
   if (mode == MODE_TRADES) {prefix = " : ";}  //  

   for(i=0; i<(OrdersTotal()+100); i++)                    //   
  {
   TMP = prefix + DoubleToStr(i,0); ObjectDelete(TMP);
  }
   for(i=0; i<OrdersTotal(); i++)                         //   
  {
   if(OrderSelect(i, SELECT_BY_POS, mode)==true && OrderSymbol()==Symbol())
  {
   if(OrderSymbol()==Symbol() && ((>=2&&(OrderType()==OP_BUY||OrderType()==OP_SELL)) || (==1&&OrderType()==OP_BUY) || (<=-1&&OrderType()==OP_SELL)))
  {
   TMP = prefix + DoubleToStr(i,0);

   if(OrderType()==OP_BUY)  {clr=Lime;}
   if(OrderType()==OP_SELL) {clr=Red;}

   ObjectCreate(TMP, OBJ_ARROW, 0, OrderOpenTime(), OrderOpenPrice());
   ObjectSet(TMP, OBJPROP_COLOR, clr);
   ObjectSet(TMP, OBJPROP_ARROWCODE, 1);
  }
  }}}
//+------------------------------------------------------------------+